/**
 *
 *  Copyright Openmind http://www.openmindonline.it
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
package net.sourceforge.openutils.mgnlcriteria.jcr.query.criterion;

import net.sourceforge.openutils.mgnlcriteria.jcr.query.Criteria;
import net.sourceforge.openutils.mgnlcriteria.jcr.query.JCRQueryException;


/**
 * @author fgrilli
 * @version $Id: IsNotNullExpression.java 1193 2009-05-08 21:05:22Z fgrilli $
 */
public class IsNotNullExpression implements Criterion
{

    private static final long serialVersionUID = -1955669039985775985L;

    protected static final String WHITESPACE = " ";

    private String nodeName;

    public IsNotNullExpression(String nodeName)
    {
        this.nodeName = nodeName;
    }

    @Override
    public String toString()
    {
        return nodeName;
    }

    public String toXPathString(Criteria criteria) throws JCRQueryException
    {
        return WHITESPACE + nodeName + WHITESPACE;
    }
}
